#!/usr/bin/env python

from emcor_tester import EmcorTester

IP = "127.0.0.1"
#IP = "134.79.218.58"

def print_bytes(words):
    for w in words:
        byte = (w >> 8) & 0xFF
        print " " + hex(byte) + " - " + chr(byte)
        byte = w & 0xFF
        print " " + hex(byte) + " - " + chr(byte)

et = EmcorTester(IP)

words = et.read(0x0010, 1)
print "Firmware version:"
print_bytes(words)

words = et.read(0x0011, 4)
print "System ID:"
print_bytes(words)

words = et.read(0x0015, 4)
print "Sub Type:"
print_bytes(words)

words = et.read(0x0019, 4)
print "Firmware date:"
print_bytes(words)

et.write(0x0001, [0xFFFF])
words = et.read(0x0000, 1)
print "Faults set:"
print_bytes(words)

et.write(0x0002, [0xFFFF])
words = et.read(0x0000, 1)
print "Faults cleared:"
print_bytes(words)
