#!/usr/bin/env python

import socket

UDP_IP = "127.0.0.1"
UDP_PORT = 4444
BUFFER_SIZE = 128

STATUS_OK = 0
METHOD_READ = 3
METHOD_WRITE = 4
METHOD_MODIFY = 5

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.bind((UDP_IP, UDP_PORT))

while True:
    data, addr = sock.recvfrom(BUFFER_SIZE)
    print "Connection address:", addr
    if not data:
        break
    print "Received data:", data
    
    data = data.split(';')[0]
    data_parts = [s.strip() for s in data.split(',')]
    if len(data_parts) < 5:
        print "MALFORMED DATA"
        break
    print "Protocol version:", data_parts[0]
    print "Message ID:", data_parts[1]
    print "Offset:", data_parts[2]
    print "Method:", data_parts[3]
    print "Width:", data_parts[4]
    if len(data_parts) > 5:
        print "Value:", data_parts[5]
    if len(data_parts) > 6:
        print "Value1:", data_parts[6]
        
    method = int(data_parts[3])
    msg = data_parts[0] + "," + data_parts[1] + "," + str(STATUS_OK)
    if method == METHOD_READ:
        msg += "," + str(METHOD_READ)
    elif method == METHOD_WRITE:
        pass
    elif method == METHOD_MODIFY:
        msg += "," + str(METHOD_MODIFY)
    msg += ";"
    
    print "msg:", msg
    sock.sendto(msg, addr)
    print "--------------------------------------------------"
